Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/unfence-parameters.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/unfence-parameters.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/unfence-parameters.dot
@@ -13,12 +13,17 @@ digraph "g" {
 "clvmd-clone_stopped_0" -> "clvmd-clone_start_0" [ style = bold]
 "clvmd-clone_stopped_0" -> "dlm-clone_stop_0" [ style = bold]
 "clvmd-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
+"clvmd:1_monitor_0 virt-2" -> "all_stopped" [ style = bold]
 "clvmd:1_monitor_0 virt-2" -> "clvmd-clone_start_0" [ style = bold]
+"clvmd:1_monitor_0 virt-2" -> "clvmd-clone_stopped_0" [ style = bold]
+"clvmd:1_monitor_0 virt-2" -> "clvmd_stop_0 virt-1" [ style = bold]
 "clvmd:1_monitor_0 virt-2" [ style=bold color="green" fontcolor="black"]
 "clvmd:1_start_0 virt-2" -> "clvmd-clone_running_0" [ style = bold]
 "clvmd:1_start_0 virt-2" -> "clvmd:2_start_0 virt-3" [ style = bold]
 "clvmd:1_start_0 virt-2" [ style=bold color="green" fontcolor="black"]
+"clvmd:2_monitor_0 virt-3" -> "all_stopped" [ style = bold]
 "clvmd:2_monitor_0 virt-3" -> "clvmd-clone_start_0" [ style = bold]
+"clvmd:2_monitor_0 virt-3" -> "clvmd-clone_stopped_0" [ style = bold]
 "clvmd:2_monitor_0 virt-3" [ style=bold color="green" fontcolor="black"]
 "clvmd:2_start_0 virt-3" -> "clvmd-clone_running_0" [ style = bold]
 "clvmd:2_start_0 virt-3" [ style=bold color="green" fontcolor="black"]
@@ -42,7 +47,9 @@ digraph "g" {
 "dlm-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "dlm-clone_stopped_0" -> "dlm-clone_start_0" [ style = bold]
 "dlm-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
+"dlm:2_monitor_0 virt-3" -> "all_stopped" [ style = bold]
 "dlm:2_monitor_0 virt-3" -> "dlm-clone_start_0" [ style = bold]
+"dlm:2_monitor_0 virt-3" -> "dlm-clone_stopped_0" [ style = bold]
 "dlm:2_monitor_0 virt-3" [ style=bold color="green" fontcolor="black"]
 "dlm:2_start_0 virt-3" -> "clvmd:2_start_0 virt-3" [ style = bold]
 "dlm:2_start_0 virt-3" -> "dlm-clone_running_0" [ style = bold]
@@ -55,6 +62,7 @@ digraph "g" {
 "dlm_stop_0 virt-1" -> "dlm_start_0 virt-1" [ style = bold]
 "dlm_stop_0 virt-1" -> "stonith 'on' virt-1" [ style = bold]
 "dlm_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
+"fencing_monitor_0 virt-3" -> "all_stopped" [ style = bold]
 "fencing_monitor_0 virt-3" -> "fencing_start_0 virt-1" [ style = bold]
 "fencing_monitor_0 virt-3" [ style=bold color="green" fontcolor="black"]
 "fencing_start_0 virt-1" [ style=bold color="green" fontcolor="black"]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/unfence-parameters.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/unfence-parameters.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/unfence-parameters.exp
@@ -121,6 +121,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="9" operation="monitor" operation_key="dlm:2_monitor_0" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <rsc_op id="12" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
@@ -207,6 +210,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="7" operation="monitor" operation_key="clvmd:1_monitor_0" on_node="virt-2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="27" operation="stop" operation_key="clvmd-clone_stop_0"/>
       </trigger>
     </inputs>
@@ -285,6 +291,12 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="7" operation="monitor" operation_key="clvmd:1_monitor_0" on_node="virt-2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="10" operation="monitor" operation_key="clvmd:2_monitor_0" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <rsc_op id="21" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
@@ -396,6 +408,18 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="7" operation="monitor" operation_key="clvmd:1_monitor_0" on_node="virt-2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="8" operation="monitor" operation_key="fencing_monitor_0" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="9" operation="monitor" operation_key="dlm:2_monitor_0" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="10" operation="monitor" operation_key="clvmd:2_monitor_0" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <rsc_op id="11" operation="stop" operation_key="fencing_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-imply-stop-on-fence.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-imply-stop-on-fence.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-imply-stop-on-fence.dot
@@ -26,7 +26,11 @@
 "clvmd-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "clvmd-clone_stopped_0" -> "dlm-clone_stop_0" [ style = bold]
 "clvmd-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
+"clvmd_monitor_0 lxc-01_kiff-02" -> "all_stopped" [ style = bold]
+"clvmd_monitor_0 lxc-01_kiff-02" -> "clvmd-clone_stopped_0" [ style = bold]
 "clvmd_monitor_0 lxc-01_kiff-02" [ style=bold color="green" fontcolor="black"]
+"clvmd_monitor_0 lxc-02_kiff-02" -> "all_stopped" [ style = bold]
+"clvmd_monitor_0 lxc-02_kiff-02" -> "clvmd-clone_stopped_0" [ style = bold]
 "clvmd_monitor_0 lxc-02_kiff-02" [ style=bold color="green" fontcolor="black"]
 "clvmd_stop_0 kiff-01" -> "all_stopped" [ style = bold]
 "clvmd_stop_0 kiff-01" -> "clvmd-clone_stopped_0" [ style = bold]
@@ -36,7 +40,11 @@
 "dlm-clone_stop_0" -> "dlm_stop_0 kiff-01" [ style = bold]
 "dlm-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "dlm-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
+"dlm_monitor_0 lxc-01_kiff-02" -> "all_stopped" [ style = bold]
+"dlm_monitor_0 lxc-01_kiff-02" -> "dlm-clone_stopped_0" [ style = bold]
 "dlm_monitor_0 lxc-01_kiff-02" [ style=bold color="green" fontcolor="black"]
+"dlm_monitor_0 lxc-02_kiff-02" -> "all_stopped" [ style = bold]
+"dlm_monitor_0 lxc-02_kiff-02" -> "dlm-clone_stopped_0" [ style = bold]
 "dlm_monitor_0 lxc-02_kiff-02" [ style=bold color="green" fontcolor="black"]
 "dlm_stop_0 kiff-01" -> "all_stopped" [ style = bold]
 "dlm_stop_0 kiff-01" -> "dlm-clone_stopped_0" [ style = bold]
@@ -68,7 +76,11 @@
 "shared0-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "shared0-clone_stopped_0" -> "clvmd-clone_stop_0" [ style = bold]
 "shared0-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
+"shared0_monitor_0 lxc-01_kiff-02" -> "all_stopped" [ style = bold]
+"shared0_monitor_0 lxc-01_kiff-02" -> "shared0-clone_stopped_0" [ style = bold]
 "shared0_monitor_0 lxc-01_kiff-02" [ style=bold color="green" fontcolor="black"]
+"shared0_monitor_0 lxc-02_kiff-02" -> "all_stopped" [ style = bold]
+"shared0_monitor_0 lxc-02_kiff-02" -> "shared0-clone_stopped_0" [ style = bold]
 "shared0_monitor_0 lxc-02_kiff-02" [ style=bold color="green" fontcolor="black"]
 "shared0_stop_0 kiff-01" -> "all_stopped" [ style = bold]
 "shared0_stop_0 kiff-01" -> "clvmd_stop_0 kiff-01" [ style = bold]
@@ -96,8 +108,10 @@
 "stonith_complete" -> "all_stopped" [ style = bold]
 "stonith_complete" -> "vm-fs_start_0 lxc-01_kiff-01" [ style = bold]
 "stonith_complete" [ style=bold color="green" fontcolor="orange"]
+"vm-fs_monitor_0 lxc-01_kiff-02" -> "all_stopped" [ style = bold]
 "vm-fs_monitor_0 lxc-01_kiff-02" -> "vm-fs_start_0 lxc-01_kiff-01" [ style = bold]
 "vm-fs_monitor_0 lxc-01_kiff-02" [ style=bold color="green" fontcolor="black"]
+"vm-fs_monitor_0 lxc-02_kiff-02" -> "all_stopped" [ style = bold]
 "vm-fs_monitor_0 lxc-02_kiff-02" -> "vm-fs_start_0 lxc-01_kiff-01" [ style = bold]
 "vm-fs_monitor_0 lxc-02_kiff-02" [ style=bold color="green" fontcolor="black"]
 "vm-fs_monitor_20000 lxc-01_kiff-01" [ style=bold color="green" fontcolor="black"]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-imply-stop-on-fence.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-imply-stop-on-fence.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-imply-stop-on-fence.exp
@@ -80,6 +80,12 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="11" operation="monitor" operation_key="dlm_monitor_0" internal_operation_key="dlm:0_monitor_0" on_node="lxc-01_kiff-02" on_node_uuid="lxc-01_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="15" operation="monitor" operation_key="dlm_monitor_0" internal_operation_key="dlm:0_monitor_0" on_node="lxc-02_kiff-02" on_node_uuid="lxc-02_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="24" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0"/>
       </trigger>
       <trigger>
@@ -146,6 +152,12 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="12" operation="monitor" operation_key="clvmd_monitor_0" internal_operation_key="clvmd:0_monitor_0" on_node="lxc-01_kiff-02" on_node_uuid="lxc-01_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="16" operation="monitor" operation_key="clvmd_monitor_0" internal_operation_key="clvmd:0_monitor_0" on_node="lxc-02_kiff-02" on_node_uuid="lxc-02_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="31" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0"/>
       </trigger>
       <trigger>
@@ -209,6 +221,12 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="13" operation="monitor" operation_key="shared0_monitor_0" internal_operation_key="shared0:0_monitor_0" on_node="lxc-01_kiff-02" on_node_uuid="lxc-01_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="17" operation="monitor" operation_key="shared0_monitor_0" internal_operation_key="shared0:0_monitor_0" on_node="lxc-02_kiff-02" on_node_uuid="lxc-02_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="38" operation="stop" operation_key="shared0_stop_0" internal_operation_key="shared0:0_stop_0"/>
       </trigger>
       <trigger>
@@ -535,6 +553,30 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="11" operation="monitor" operation_key="dlm_monitor_0" internal_operation_key="dlm:0_monitor_0" on_node="lxc-01_kiff-02" on_node_uuid="lxc-01_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="12" operation="monitor" operation_key="clvmd_monitor_0" internal_operation_key="clvmd:0_monitor_0" on_node="lxc-01_kiff-02" on_node_uuid="lxc-01_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="13" operation="monitor" operation_key="shared0_monitor_0" internal_operation_key="shared0:0_monitor_0" on_node="lxc-01_kiff-02" on_node_uuid="lxc-01_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="14" operation="monitor" operation_key="vm-fs_monitor_0" on_node="lxc-01_kiff-02" on_node_uuid="lxc-01_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="15" operation="monitor" operation_key="dlm_monitor_0" internal_operation_key="dlm:0_monitor_0" on_node="lxc-02_kiff-02" on_node_uuid="lxc-02_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="16" operation="monitor" operation_key="clvmd_monitor_0" internal_operation_key="clvmd:0_monitor_0" on_node="lxc-02_kiff-02" on_node_uuid="lxc-02_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="17" operation="monitor" operation_key="shared0_monitor_0" internal_operation_key="shared0:0_monitor_0" on_node="lxc-02_kiff-02" on_node_uuid="lxc-02_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="18" operation="monitor" operation_key="vm-fs_monitor_0" on_node="lxc-02_kiff-02" on_node_uuid="lxc-02_kiff-02" router_node="kiff-02"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="21" operation="stop" operation_key="fence-kiff-02_stop_0"/>
       </trigger>
       <trigger>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-migrate1.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-migrate1.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-migrate1.dot
@@ -26,6 +26,8 @@
 "rhel7-node1_migrate_from_0 rhel7-node3" [ style=bold color="green" fontcolor="black"]
 "rhel7-node1_migrate_to_0 rhel7-node2" -> "rhel7-node1_migrate_from_0 rhel7-node3" [ style = bold]
 "rhel7-node1_migrate_to_0 rhel7-node2" [ style=bold color="green" fontcolor="black"]
+"rhel7-node1_monitor_0 rhel7-node3" -> "all_stopped" [ style = bold]
+"rhel7-node1_monitor_0 rhel7-node3" -> "remote-rsc_migrate_to_0 rhel7-node2" [ style = bold]
 "rhel7-node1_monitor_0 rhel7-node3" -> "rhel7-node1_migrate_to_0 rhel7-node2" [ style = bold]
 "rhel7-node1_monitor_0 rhel7-node3" -> "rhel7-node1_start_0 rhel7-node3" [ style = bold]
 "rhel7-node1_monitor_0 rhel7-node3" [ style=bold color="green" fontcolor="black"]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-migrate1.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-migrate1.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-migrate1.exp
@@ -89,7 +89,11 @@
         <attributes CRM_meta_migrate_source="rhel7-node2" CRM_meta_migrate_target="rhel7-node3" CRM_meta_on_node="rhel7-node2" CRM_meta_on_node_uuid="2" CRM_meta_record_pending="true" CRM_meta_remote_node="rhel7-node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
-    <inputs/>
+    <inputs>
+      <trigger>
+        <rsc_op id="12" operation="monitor" operation_key="rhel7-node1_monitor_0" on_node="rhel7-node3" on_node_uuid="3"/>
+      </trigger>
+    </inputs>
   </synapse>
   <synapse id="8">
     <action_set>
@@ -228,6 +232,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="12" operation="monitor" operation_key="rhel7-node1_monitor_0" on_node="rhel7-node3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <rsc_op id="13" operation="stop" operation_key="shooter1_stop_0" on_node="rhel7-node3" on_node_uuid="3"/>
       </trigger>
       <trigger>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-move.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-move.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-move.dot
@@ -1,5 +1,7 @@
 digraph "g" {
 "A_monitor_0 lxc2" -> "A_start_0 lxc1" [ style = bold]
+"A_monitor_0 lxc2" -> "all_stopped" [ style = bold]
+"A_monitor_0 lxc2" -> "lxc1_stop_0 18node1" [ style = bold]
 "A_monitor_0 lxc2" [ style=bold color="green" fontcolor="black"]
 "A_monitor_10000 lxc1" [ style=bold color="green" fontcolor="black"]
 "A_start_0 lxc1" -> "A_monitor_10000 lxc1" [ style = bold]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-move.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-move.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-move.exp
@@ -223,6 +223,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="10" operation="monitor" operation_key="A_monitor_0" on_node="lxc2" on_node_uuid="lxc2" router_node="18node2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="23" operation="stop" operation_key="M_stop_0" internal_operation_key="M:3_stop_0" on_node="lxc1" on_node_uuid="lxc1" router_node="18node1"/>
       </trigger>
       <trigger>
@@ -238,6 +241,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="10" operation="monitor" operation_key="A_monitor_0" on_node="lxc2" on_node_uuid="lxc2" router_node="18node2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="11" operation="stop" operation_key="container1_stop_0" on_node="18node1" on_node_uuid="1"/>
       </trigger>
       <trigger>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-ms-ordering.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-ms-ordering.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-ms-ordering.dot
@@ -2,20 +2,26 @@
 "all_stopped" -> "lxc1_start_0 18node1" [ style = bold]
 "all_stopped" -> "lxc2_start_0 18node1" [ style = bold]
 "all_stopped" [ style=bold color="green" fontcolor="orange"]
+"container1_monitor_0 18node1" -> "all_stopped" [ style = bold]
 "container1_monitor_0 18node1" -> "container1_start_0 18node1" [ style = bold]
 "container1_monitor_0 18node1" [ style=bold color="green" fontcolor="black"]
+"container1_monitor_0 18node2" -> "all_stopped" [ style = bold]
 "container1_monitor_0 18node2" -> "container1_start_0 18node1" [ style = bold]
 "container1_monitor_0 18node2" [ style=bold color="green" fontcolor="black"]
+"container1_monitor_0 18node3" -> "all_stopped" [ style = bold]
 "container1_monitor_0 18node3" -> "container1_start_0 18node1" [ style = bold]
 "container1_monitor_0 18node3" [ style=bold color="green" fontcolor="black"]
 "container1_start_0 18node1" -> "lxc-ms_promote_0 lxc1" [ style = bold]
 "container1_start_0 18node1" -> "lxc-ms_start_0 lxc1" [ style = bold]
 "container1_start_0 18node1" -> "lxc1_start_0 18node1" [ style = bold]
 "container1_start_0 18node1" [ style=bold color="green" fontcolor="black"]
+"container2_monitor_0 18node1" -> "all_stopped" [ style = bold]
 "container2_monitor_0 18node1" -> "container2_start_0 18node1" [ style = bold]
 "container2_monitor_0 18node1" [ style=bold color="green" fontcolor="black"]
+"container2_monitor_0 18node2" -> "all_stopped" [ style = bold]
 "container2_monitor_0 18node2" -> "container2_start_0 18node1" [ style = bold]
 "container2_monitor_0 18node2" [ style=bold color="green" fontcolor="black"]
+"container2_monitor_0 18node3" -> "all_stopped" [ style = bold]
 "container2_monitor_0 18node3" -> "container2_start_0 18node1" [ style = bold]
 "container2_monitor_0 18node3" [ style=bold color="green" fontcolor="black"]
 "container2_start_0 18node1" -> "lxc-ms_start_0 lxc2" [ style = bold]
@@ -48,11 +54,17 @@
 "lxc-ms_demote_0 lxc1" -> "lxc-ms_promote_0 lxc1" [ style = bold]
 "lxc-ms_demote_0 lxc1" -> "lxc-ms_stop_0 lxc1" [ style = bold]
 "lxc-ms_demote_0 lxc1" [ style=bold color="green" fontcolor="orange"]
+"lxc-ms_monitor_0 18node1" -> "all_stopped" [ style = bold]
 "lxc-ms_monitor_0 18node1" -> "lxc-ms-master_start_0" [ style = bold]
+"lxc-ms_monitor_0 18node1" -> "lxc-ms-master_stopped_0" [ style = bold]
 "lxc-ms_monitor_0 18node1" [ style=bold color="green" fontcolor="black"]
+"lxc-ms_monitor_0 18node2" -> "all_stopped" [ style = bold]
 "lxc-ms_monitor_0 18node2" -> "lxc-ms-master_start_0" [ style = bold]
+"lxc-ms_monitor_0 18node2" -> "lxc-ms-master_stopped_0" [ style = bold]
 "lxc-ms_monitor_0 18node2" [ style=bold color="green" fontcolor="black"]
+"lxc-ms_monitor_0 18node3" -> "all_stopped" [ style = bold]
 "lxc-ms_monitor_0 18node3" -> "lxc-ms-master_start_0" [ style = bold]
+"lxc-ms_monitor_0 18node3" -> "lxc-ms-master_stopped_0" [ style = bold]
 "lxc-ms_monitor_0 18node3" [ style=bold color="green" fontcolor="black"]
 "lxc-ms_monitor_10000 lxc2" [ style=bold color="green" fontcolor="black"]
 "lxc-ms_promote_0 lxc1" -> "lxc-ms-master_promoted_0" [ style = bold]
@@ -71,10 +83,13 @@
 "lxc-ms_stop_0 lxc2" -> "lxc-ms-master_stopped_0" [ style = bold]
 "lxc-ms_stop_0 lxc2" -> "lxc-ms_start_0 lxc2" [ style = bold]
 "lxc-ms_stop_0 lxc2" [ style=bold color="green" fontcolor="orange"]
+"lxc1_monitor_0 18node1" -> "all_stopped" [ style = bold]
 "lxc1_monitor_0 18node1" -> "lxc1_start_0 18node1" [ style = bold]
 "lxc1_monitor_0 18node1" [ style=bold color="green" fontcolor="black"]
+"lxc1_monitor_0 18node2" -> "all_stopped" [ style = bold]
 "lxc1_monitor_0 18node2" -> "lxc1_start_0 18node1" [ style = bold]
 "lxc1_monitor_0 18node2" [ style=bold color="green" fontcolor="black"]
+"lxc1_monitor_0 18node3" -> "all_stopped" [ style = bold]
 "lxc1_monitor_0 18node3" -> "lxc1_start_0 18node1" [ style = bold]
 "lxc1_monitor_0 18node3" [ style=bold color="green" fontcolor="black"]
 "lxc1_monitor_30000 18node1" [ style=bold color="green" fontcolor="black"]
@@ -82,10 +97,13 @@
 "lxc1_start_0 18node1" -> "lxc-ms_start_0 lxc1" [ style = bold]
 "lxc1_start_0 18node1" -> "lxc1_monitor_30000 18node1" [ style = bold]
 "lxc1_start_0 18node1" [ style=bold color="green" fontcolor="black"]
+"lxc2_monitor_0 18node1" -> "all_stopped" [ style = bold]
 "lxc2_monitor_0 18node1" -> "lxc2_start_0 18node1" [ style = bold]
 "lxc2_monitor_0 18node1" [ style=bold color="green" fontcolor="black"]
+"lxc2_monitor_0 18node2" -> "all_stopped" [ style = bold]
 "lxc2_monitor_0 18node2" -> "lxc2_start_0 18node1" [ style = bold]
 "lxc2_monitor_0 18node2" [ style=bold color="green" fontcolor="black"]
+"lxc2_monitor_0 18node3" -> "all_stopped" [ style = bold]
 "lxc2_monitor_0 18node3" -> "lxc2_start_0 18node1" [ style = bold]
 "lxc2_monitor_0 18node3" [ style=bold color="green" fontcolor="black"]
 "lxc2_monitor_30000 18node1" [ style=bold color="green" fontcolor="black"]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-ms-ordering.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-ms-ordering.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-ms-ordering.exp
@@ -327,6 +327,15 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="lxc-ms_monitor_0" internal_operation_key="lxc-ms:0_monitor_0" on_node="18node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="10" operation="monitor" operation_key="lxc-ms_monitor_0" internal_operation_key="lxc-ms:0_monitor_0" on_node="18node2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="15" operation="monitor" operation_key="lxc-ms_monitor_0" internal_operation_key="lxc-ms:0_monitor_0" on_node="18node3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="23" operation="stop" operation_key="lxc-ms_stop_0" internal_operation_key="lxc-ms:0_stop_0"/>
       </trigger>
       <trigger>
@@ -572,6 +581,51 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="container1_monitor_0" on_node="18node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="container2_monitor_0" on_node="18node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="lxc-ms_monitor_0" internal_operation_key="lxc-ms:0_monitor_0" on_node="18node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="6" operation="monitor" operation_key="lxc1_monitor_0" on_node="18node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="7" operation="monitor" operation_key="lxc2_monitor_0" on_node="18node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="8" operation="monitor" operation_key="container1_monitor_0" on_node="18node2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="9" operation="monitor" operation_key="container2_monitor_0" on_node="18node2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="10" operation="monitor" operation_key="lxc-ms_monitor_0" internal_operation_key="lxc-ms:0_monitor_0" on_node="18node2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="11" operation="monitor" operation_key="lxc1_monitor_0" on_node="18node2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="12" operation="monitor" operation_key="lxc2_monitor_0" on_node="18node2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="13" operation="monitor" operation_key="container1_monitor_0" on_node="18node3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="14" operation="monitor" operation_key="container2_monitor_0" on_node="18node3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="15" operation="monitor" operation_key="lxc-ms_monitor_0" internal_operation_key="lxc-ms:0_monitor_0" on_node="18node3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="16" operation="monitor" operation_key="lxc1_monitor_0" on_node="18node3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="17" operation="monitor" operation_key="lxc2_monitor_0" on_node="18node3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="23" operation="stop" operation_key="lxc-ms_stop_0" internal_operation_key="lxc-ms:0_stop_0"/>
       </trigger>
       <trigger>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-orphaned.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-orphaned.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-orphaned.dot
@@ -1,6 +1,9 @@
  digraph "g" {
+"A_monitor_0 lxc2" -> "all_stopped" [ style = bold]
 "A_monitor_0 lxc2" [ style=bold color="green" fontcolor="black"]
 "B_monitor_0 lxc2" -> "B_start_0 lxc2" [ style = bold]
+"B_monitor_0 lxc2" -> "all_stopped" [ style = bold]
+"B_monitor_0 lxc2" -> "lxc1_stop_0 18node2" [ style = bold]
 "B_monitor_0 lxc2" [ style=bold color="green" fontcolor="black"]
 "B_monitor_10000 lxc2" [ style=bold color="green" fontcolor="black"]
 "B_start_0 lxc2" -> "B_monitor_10000 lxc2" [ style = bold]
@@ -9,6 +12,7 @@
 "B_stop_0 lxc1" -> "all_stopped" [ style = bold]
 "B_stop_0 lxc1" -> "lxc1_stop_0 18node2" [ style = bold]
 "B_stop_0 lxc1" [ style=bold color="green" fontcolor="black"]
+"D_monitor_0 lxc2" -> "all_stopped" [ style = bold]
 "D_monitor_0 lxc2" [ style=bold color="green" fontcolor="black"]
 "M-clone_stop_0" -> "M-clone_stopped_0" [ style = bold]
 "M-clone_stop_0" -> "M_stop_0 lxc1" [ style = bold]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-orphaned.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-orphaned.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-orphaned.exp
@@ -176,6 +176,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="20" operation="monitor" operation_key="B_monitor_0" on_node="lxc2" on_node_uuid="lxc2" router_node="18node2"/>
+      </trigger>
+      <trigger>
         <crm_event id="23" operation="clear_failcount" operation_key="lxc1_clear_failcount_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
       <trigger>
@@ -242,6 +245,15 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="19" operation="monitor" operation_key="A_monitor_0" on_node="lxc2" on_node_uuid="lxc2" router_node="18node2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="20" operation="monitor" operation_key="B_monitor_0" on_node="lxc2" on_node_uuid="lxc2" router_node="18node2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="21" operation="monitor" operation_key="D_monitor_0" on_node="lxc2" on_node_uuid="lxc2" router_node="18node2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="36" operation="stop" operation_key="M_stop_0" internal_operation_key="M:4_stop_0" on_node="lxc1" on_node_uuid="lxc1" router_node="18node2"/>
       </trigger>
       <trigger>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-stop.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-stop.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-stop.dot
@@ -1,6 +1,9 @@
 digraph "g" {
+"A_monitor_0 lxc2" -> "all_stopped" [ style = bold]
 "A_monitor_0 lxc2" [ style=bold color="green" fontcolor="black"]
 "B_monitor_0 lxc2" -> "B_start_0 lxc2" [ style = bold]
+"B_monitor_0 lxc2" -> "all_stopped" [ style = bold]
+"B_monitor_0 lxc2" -> "lxc1_stop_0 18node2" [ style = bold]
 "B_monitor_0 lxc2" [ style=bold color="green" fontcolor="black"]
 "B_monitor_10000 lxc2" [ style=bold color="green" fontcolor="black"]
 "B_start_0 lxc2" -> "B_monitor_10000 lxc2" [ style = bold]
@@ -9,6 +12,7 @@ digraph "g" {
 "B_stop_0 lxc1" -> "all_stopped" [ style = bold]
 "B_stop_0 lxc1" -> "lxc1_stop_0 18node2" [ style = bold]
 "B_stop_0 lxc1" [ style=bold color="green" fontcolor="black"]
+"D_monitor_0 lxc2" -> "all_stopped" [ style = bold]
 "D_monitor_0 lxc2" [ style=bold color="green" fontcolor="black"]
 "M-clone_stop_0" -> "M-clone_stopped_0" [ style = bold]
 "M-clone_stop_0" -> "M_stop_0 lxc1" [ style = bold]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-stop.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/whitebox-stop.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/whitebox-stop.exp
@@ -125,6 +125,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="14" operation="monitor" operation_key="B_monitor_0" on_node="lxc2" on_node_uuid="lxc2" router_node="18node2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="29" operation="stop" operation_key="M_stop_0" internal_operation_key="M:4_stop_0" on_node="lxc1" on_node_uuid="lxc1" router_node="18node2"/>
       </trigger>
       <trigger>
@@ -140,6 +143,15 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="13" operation="monitor" operation_key="A_monitor_0" on_node="lxc2" on_node_uuid="lxc2" router_node="18node2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="14" operation="monitor" operation_key="B_monitor_0" on_node="lxc2" on_node_uuid="lxc2" router_node="18node2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="15" operation="monitor" operation_key="D_monitor_0" on_node="lxc2" on_node_uuid="lxc2" router_node="18node2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="16" operation="stop" operation_key="container1_stop_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
       <trigger>
